<template>
  <div class="sce-card-deck row row-deck h-100">
    <template v-for="(set, index) in inputSets">
      <div
        v-show="isActive(set.key)"
        :key="set.index"
        class="rimow-card card-sce-params col-12 h-100"
      >
        <ParametersCard
          :set="set"
          :next-set="inputSets[index + 1]"
          :previous-set="inputSets[index - 1]"
        />
      </div>
    </template>
  </div>
</template>

<script>
export default {
  props: {
    parameters: {
      type: Array,
      default: () => [],
    },
  },
  computed: {
    inputSets() {
      const result = [];
      const stack = [...this.parameters];
      while (stack.length > 0) {
        const current = stack.pop();
        let hasAnyInput = false;
        for (const child of current.parameters) {
          if (child.type === 'group') {
            stack.unshift(child);
          } else {
            hasAnyInput = true;
          }
        }
        if (hasAnyInput) {
          result.push(current);
        }
      }
      return result;
    },
  },
  methods: {
    isActive(key) {
      return (
        key === this.$nuxt.context.store.getters['parameters/activeSet'].setKey
      );
    },
  },
};
</script>
